#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################





__author__  = 'Arthur Chan'
__docformat__ = 'restructuredtext'

from Products.ATContentTypes.config import *

from urllib import quote

if HAS_LINGUA_PLONE:
    from Products.LinguaPlone.public import registerType, BaseContent
else:
    from Products.Archetypes.public import registerType,BaseContent

from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import getToolByName
from AccessControl import ClassSecurityInfo
from ComputedAttribute import ComputedAttribute
from Products.PortalTransforms.utils import TransformException

from Products.ATContentTypes.types.ATContentType import ATCTContent, updateActions
from Products.ATContentTypes.interfaces.IATFile import IATFile
from Products.ATContentTypes.types.schemata import ATFileSchema, ATExtFileSchema

from Products.ATContentTypes.types.ATFile import ATFile


from OFS.Image import File
from Acquisition import aq_parent

from zLOG import LOG, WARNING, BLATHER, INFO

##### non atfile library ###
from Globals import package_home
#from Products.Archetypes.public import BaseFolderSchema, Schema
from Products.Archetypes.public import Schema
#from Products.Archetypes.public import BaseFolder, registerType

from Products.Archetypes.public import DateTimeField, FileField, StringField, TextField
from Products.Archetypes.public import CalendarWidget, SelectionWidget, StringWidget, TextAreaWidget


#from Products.CMFCore import CMFCorePermissions
#from AccessControl import ClassSecurityInfo

#from Products.CMFCore.utils import getToolByName

from Products.CMFDocMgt.config import *


from AccessControl import getSecurityManager, SpecialUsers
from Acquisition import aq_base, aq_parent, aq_chain

from OFS.ObjectManager import ObjectManager
#from Products.CMFDefault.File import File

from DateTime import DateTime
import string

import os.path, string, mimetypes

DOC_ICONS_FILE = package_home(globals()) + '/data/doc_icons.props'  

#############################################################################
##                             Setting                                     ##
#############################################################################

schema = ATFileSchema +  Schema((
    StringField('id',
                 required=1,
                ),
    StringField('title',
                required=1,
                ),
    FileField('file',
                primary=1,
                mutator='changeFile',
                ),
    StringField('contact',
                required=1,
                default='',
                widget=StringWidget(label_msgid='label_contact',i18n_domain='CMFDocMgt',description=' ',),
                ),
    StringField('docstatus',
                vocabulary=DOCSTATUS,
                default='0',
                widget=SelectionWidget(label_msgid='label_docstatus',i18n_domain='CMFDocMgt',description=' ',),
                ),
    TextField('description',
                widget=TextAreaWidget(label_msgid='label_description',),
                ),
    #StringField('content_type',
    #            vocabulary='getAvailableContentType',
    #            default='',
    #            widget=SelectionWidget(label_msgid='label_content_type',i18n_domain='CMFDocMgt',description=' ',),
    #            ),
    DateTimeField('deadline',
                widget=CalendarWidget(label_msgid='label_deadline',i18n_domain='CMFDocMgt',description=' ',),
                ),
    StringField('email',
                validator='validate_email',
                default='',
                widget=StringWidget(label_msgid='label_email',i18n_domain='CMFDocMgt',description=' ',),
                ),
    StringField('actionusr',
                mutator='changeActionUser',
                mode='r',
                ),
    DateTimeField('actiondate',
                mutator='changeActionDate',
                mode='r',
                ),
    ))
    
#def cleanupFilename(filename):
#    result = ''
#    for s in str(filename):
#        s = CHAR_MAPPING.get(s, s)
#        if s in GOOD_CHARS:
#            result+=s
#    return result
    
#def addDocMgtFile( self
#           , id=''
#           , title=''
#           , file=''
#           , precondition=''
#           ):
#    self=self.this()
#    if title=='':
#        title=id
#    bnNew = hasattr(self, id)
#    
#    fobj = DocMgtFile( id, title=title, file=file, precondition=precondition
#               )
#    
#    portal_membership = self.portal_membership
#    author = portal_membership.getAuthenticatedMember()
#    
#    values={}
#    values['author'] =author
#    fobj.processForm(data=1, metadata=0, REQUEST=None, values=values)
#    #fobj.insertProperties(author)
#    # Add the File instance to self
#    #self.allowDiscussion = 1
#    
#    self._setObject(id, fobj)
#    #self._getOb(id).manage_upload(file)
#    
#    #obj = self.__of__()
#    #newpath= self.getRevPath()
#    #self.RevisionManager.add([newpath])
    
class DocMgtFile(ATFile):
    """
        DocMgtFile is the file objects for CVS
    """
    
    
    schema = schema
    
    content_icon   = 'file_icon.gif'
    meta_type      = 'DocMgtFile'
    archetype_name = 'File'
    immediate_view = 'docmgtfile_view'
    default_view   = 'docmgtfile_view'
    #suppl_views    = ()
    newTypeFor     = ()
    #typeDescription= "Add the relevant details of the file to be added in the form below,\n" \
    #                 "select the file with the 'Browse' button, and press 'Save'."
    typeDescMsgId  = 'description_edit_file'
    assocMimetypes = ('application/*', 'audio/*', 'video/*', 'image/*')
    assocFileExt   = ('doc', 'xls', 'ppt', 'wav', 'mp3', 'jpg','tif', 'bmp', 'gif')
    allow_discussion = 1
    
    #__implements__ = ATCTContent.__implements__, IATFile

    _doc_icons_map = {}
    security = ClassSecurityInfo()
    
    
    global_allow = 0
    
    actions = updateActions(ATCTContent,(
          { 'id'            : 'folderContents'
            , 'name'          : 'Contents'
            , 'action'        : 'string: ${folder_url}/folder_contents'
            , 'condition'      : 'python:member and folder is not object and object.displayContentsTab()'
            , 'permissions'   : (CMFCorePermissions.ListFolderContents, )
            , 'category'       : 'object'
            , 'visible':0
            }
          , { 'id'            : 'metadata'
            , 'name'          : 'Properties'
            , 'action'        : 'string:${object_url}/base_metadata'
            , 'permissions'   : (CMFCorePermissions.ModifyPortalContent, )
            , 'category'       : 'object'
            , 'visible':0
            }
          , { 'id'            : 'view'
            , 'name'          : 'View'
            , 'action'        : 'string:docmgtfile_view'
            , 'permissions'   : (CMFCorePermissions.View, )
            }
          , {
            'id'          : 'download',
            'name'        : 'Download',
            'action'      : 'string:${object_url}/download',
            'permissions' : (CMFCorePermissions.View,)
             },
        )
    )

    
    ################# override default pages/actions #####################
    
    
    #getName = ComputedAttribute(id, 1)
    
    security.declareProtected(CMFCorePermissions.View, 'index_html')
    def index_html(self, REQUEST=None, RESPONSE=None):
        """Download the file
        """
        
        return self.downloadRev(reqrev='', REQUEST=REQUEST, RESPONSE=RESPONSE)
    
    #index_html = ComputedAttribute(index_html, 1)
        
    security.declareProtected(CMFCorePermissions.View, 'download')
    def download(self, REQUEST, RESPONSE):
        """Download the file (use default index_html)
        """
        return self.downloadRev(reqrev='', REQUEST=REQUEST, RESPONSE=RESPONSE)
    
    #security.declarePublic('getAvailableContentType')
    #def getAvailableContentType(self):
    #    return self.plone_utils.availableMIMETypes()
    
    
    
    security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'changeActionUser' )        
    def changeActionUser(self, value):
        schema = self.Schema()
        field = schema.get('actionusr', None)
        field.set(instance=self, value=value)
        self.changeActionDate(DateTime().strftime('%Y/%m/%d %H:%M'))
    
    security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'changeActionDate' )        
    def changeActionDate(self, value):
        schema = self.Schema()
        field = schema.get('actiondate', None)
        field.set(instance=self, value=value)
    
    security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'changeFile' )        
    def changeFile(self, value):
        oldsize= self.get_size()
        
        schema = self.Schema()
        field = schema.get('file', None)
        field.set(instance=self, value=value)
        if value:
            log = 'File content updated'
            if hasattr(self, 'REQUEST'):
                if hasattr(self.REQUEST, 'log'):
                    log = self.REQUEST.get('log')
                
            self.addOrUpdateRev(oldsize, log=log)
            
        
    #security.declarePrivate( '_initDocIcons' )        
    #def _initDocIcons( self ):
    #    """
    #        Initialize Doc Icons Map
    #    """        
    #    f = open(DOC_ICONS_FILE, 'rb')
    #    lines = [line.strip().lower() for line in f.readlines()]
    #    
    #    icon_map = self.getDocIconsMap()
    #    
    #    for line in lines:
    #        if line.startswith('#' ): continue # comment
    #        
    #        try:
    #            name = line.split(':')[0].strip()
    #            icon = line.split(':')[1].strip()
    #        except:
    #            continue
    #        
    #        icon_map[name] = icon


    security.declarePublic( 'getIcon' )
    def getIcon( self, relative_to_portal=0 ):
        """
            Return icon depending on media type
        """
        #i = self.getDocIcon(name=self.get_content_type())
        #if not i:
        #    i = 'file_icon.gif'
        #return i
        return self.getBestIcon()
    
    security.declarePublic( 'get_content_type' )
    def get_content_type(self):
        return self.getContentType()
    
    
    #security.declarePublic( 'getDocIconMap' )        
    #def getDocIconsMap( self ):
    #    """
    #       Return the media icons map
    #    """
    #    
    #    return DocMgtFile._doc_icons_map
        
    #security.declarePublic( 'getDocIcon' )        
    #def getDocIcon( self, name ):
    #    """
    #       Return the requested document icon
    #    """
    #    
    #    icon_map = self.getDocIconsMap()
    #    
    #    if not len(icon_map ):
    #        self._initDocIcons()
    #        icon_map = self.getDocIconsMap()
    #    
    #    if icon_map.has_key(name ):
    #        return icon_map[name]
    #
    #    return icon_map['etc']
    
    
    
        
    security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'edit' )
    def edit( self, title=None, description=None, file='', \
        contact=None, email=None, docstatus=None, actionusr=None, deadline=None, **kwag ):
        """
            Edit File
        """
        self._check_lock()
        
        oldsize= self.get_size()
        
        #File.edit( self, file=file)
        
        if kwag.has_key('log'):
            log = kwag['log']
        else:
            log=''
            
        self.REQUEST.set('log', log)
        self.changeFile(file)
        
        values={}
        
        values['contact'] = contact
        
        if email <> None:
            values['email'] = email
        elif kwag.has_key('email'):
            values['email'] = kwag['email']
        if docstatus <> None:
            values['docstatus'] = docstatus
        elif kwag.has_key('docstatus'):
            values['docstatus'] = kwag['docstatus']
        
            
        if deadline <> None:
            values['deadline'] = deadline
        elif kwag.has_key('deadline'):
            values['deadline'] = kwag['deadline']
        
        if title <> None:
            values['title'] = title
        elif kwag.has_key('title'):
            values['title']= kwag['title']
        if description <> None:
            values['description'] =description
        elif kwag.has_key('description'):
            values['description'] = kwag['description']
        
        #if content_type <> '':
        #    values['content_type'] = content_type
        #elif kwag.has_key('content_type'):
        #    values['content_type'] = kwag['content_type']
        #elif getattr(file, 'filename', '')<> '':
        #    body, size = self._read_data(file)        
        #    if type(body) is not type(''): body=body.data
        #    tool = self.cmfdocmgt_tool
        #    ct=guess_content_type(getattr(file, 'filename',self.getId()), body, getattr(self, 'content_type', tool.DefaultContentType))
        #    
        #    values['content_type']  = ct[0]
        
        if values:
            self.processForm(data=1, metadata=0, REQUEST=None, values=values)
        
        if actionusr <> None:
            self.changeActionUser(actionusr)
            
        elif kwag.has_key('actionusr'):
            self.changeActionUser(kwag['actionusr'])
            
            
        norev=0
        if kwag.has_key('norev'):
            if kwag['norev'] ==1:
                norev=1
        if getattr(file, 'filename', '')<> '' and norev==0 :
        
            #revmgr = self.RevisionManager
            #newpath= self.getRevPath()
            if not self.REQUEST.get('MappingRM', 0):
                
                
                self.addOrUpdateRev(oldsize, log=log)
               
    
    def addOrUpdateRev(self, oldsize=0, log=''):
        if hasattr(self, 'REQUEST'):
            if getattr(self.REQUEST, 'MappingRM', 0):
                return 
        if oldsize == 0:
            self.addRev()
        else:
            
            if log:
                log = log
            else:
                log = 'New Content Updated'
                
            self.updateRev(log)

        


    security.declarePrivate('manage_afterAdd')
    def manage_afterAdd(self, item, container):
        ATFile.manage_afterAdd(self,item, container)
        portal_membership = self.portal_membership
        auth = portal_membership.getAuthenticatedMember()
        contact = auth.getMemberId()
        values={}
        values['contact'] =contact
        
        if values:
            self.processForm(data=1, metadata=0, REQUEST=None, values=values)
        
        self.addRev()



        
    security.declarePrivate('manage_beforeDelete')
    def manage_beforeDelete(self, item, container):
        ATFile.manage_beforeDelete(self,item, container)
        if self.get_size():
            self.removeRev()
            
        #if self.get_size():
        #    newpath= self.getRevPath()
        #    self.RevisionManager.remove([newpath])
            
            
        #self.RevisionManager.commit('system commit', [newpath])

    security.declarePrivate('manage_afterClone')
    def manage_afterClone(self, item):
        
        ATFile.manage_afterClone(self,item)
        self.addRev()
        #if self.get_size():
        #    newpath= self.getRevPath()
        #    self.RevisionManager.add([newpath])
        #self.RevisionManager.commit('system commit', [oldpath, newpath])


    #############################################################################
    ##                             RevisionManager                             ##
    #############################################################################

    def read(self):
        return self.get_data()
        
    def findparent(object):
        """ find the direct parent """
    
        for parent in aq_chain(object):
            if parent is object:
                continue
            if parent == object:
                continue
            if isinstance(parent, ObjectManager):
                return parent
        return None    

    security.declarePublic( "logRev")
    def logRev(self, paths):
        revmgr = self.RevisionManager
        if not paths:
            return {}

        # write objects to FS
        #all_paths = self.addParentAndChildPaths(paths)
        #self.writeToFS(all_paths)

        if revmgr._settings['save_properties']:
            file_paths = paths
            for abs_filename in file_paths :
                basename = os.path.basename(abs_filename)
                dirname = os.path.dirname(abs_filename)
                prop_path = os.path.join(dirname, "." + basename + '.properties')
                    
                if os.path.isfile(prop_path):
                    paths = paths.append(prop_path)
                    

        
            #paths = revmgr.addPropertyPaths(paths)
        paths = revmgr._escape_spaces(paths)

        # retrieve cvs log information
        cvs = revmgr._get_wrapper()
        revmgr.clearLazyTraverse()
        return cvs.log(" ".join(paths))

    security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'updateRev' )
    def updateRev( self, log):
        if self.get_size():
            revmgr = self.getRM()
            newpath= self.getRevPath()
            revmgr.status([newpath])
            
            #cvs = revmgr._get_wrapper()
            
            revmgr.update([newpath], tag='', reset_sticky=1)
            
            #cvs.update(newpath, reset_sticky=1)
            #LOG('CMFDocMgt', INFO, 'reset sticky for %s ' % newpath)
            #def update(self, filename="", tag="", recursive=1, prune_empty=0,
            #   new_dirs=0, reset_sticky=0):
            tool = self.cmfdocmgt_tool
            if tool.LogUser:
                contact = self.portal_membership.getAuthenticatedMember().getUserName()
                log = '[' + contact + ']' + log
            revmgr.commit(log, [newpath])
            
            #LOG('CMFDocMgt', INFO, 'Updated the revision for %s ' % newpath)

    security.declarePrivate('addRev')
    def addRev( self ):
        if not self:
            return
        if self.get_size():
            revmgr = self.getRM()
            newpath= self.getRevPath()
            LOG('CMFDocMgt', INFO, 'Adding the revision for %s ' % newpath)
            
            revmgr.add([newpath])
        #else:
        #    revmgr = self.getRM()
        #    newpath= self.getRevPath()
        #    revmgr.status([newpath])
        #    log = "Modified By RevisionManager"
        #    revmgr.commit(log, [newpath])
    
    security.declarePrivate('removeRev')
    def removeRev( self ):
        if self.get_size():
            revmgr = self.getRM()
            newpath= self.getRevPath()
            revmgr.remove([newpath])
            #LOG('CMFDocMgt', INFO, 'Removed the revision for %s ' % newpath)

    def getRM(self):
        #paths = self.getPhysicalPath()
        #lp = len(paths)
        #found = None
        
        parent = self
        
        while not hasattr(aq_base(parent), 'RevisionManager'):
            LOG('CMFDocMgt', INFO, 'Finding parent for %s ' % parent.id)
            #parent = aq_parent(aq_base(parent)) #parent.findparent()
            parent = parent.findparent()
            LOG('CMFDocMgt', INFO, 'The parent is %s ' % parent.id)
            
        return parent['RevisionManager']
        
    def getRMParent(self):
        parent = self
        while not hasattr(aq_base(parent), 'RevisionManager'):
            parent = parent.findparent()
        
        
        return parent
        
    def getRevPath(self):
        paths = self.getPhysicalPath()
        rmp = self.getRMParent()
        if rmp:
            return '/'.join(paths[len(rmp.getPhysicalPath()):])

    #def getPropertyValue( self, name, properties='' ):
    #    """
    #    Get the property Value
    #    """
    #
    #    if properties:
    #        pa = properties.split('\n')
    #        for i in range(len(pa)):
    #            try:
    #                tmp= pa[i].split('=')
    #                key = tmp[0]
    #                value=tmp[1]
    #                if key[:len(name)+1]==name + ':':
    #                    return value
    #            except:
    #                continue
    #        
    #def getPropertyRev( self, logprop, revdate):
    #    """
    #    Try to get the property rev tag which has the smallest date difference from the file rev
    #    """
    #    if logprop ==None:
    #        return
    #        
    #    revisions = logprop['revisions']
    #    diff = -1
    #    rdate = float(revdate)
    #    ret = ''
    #    for rev in revisions:
    #        tmp = abs(rdate - rev['date'] )
    #        if tmp < diff or diff == -1:
    #            ret = rev['revision']
    #            diff = tmp
    #    return ret
        
        
        
    #    obj_status = revmgr.getStatus(path)
    #    data = File.manage_FTPget(self)
    #    #if obj_last_modified < obj_status.get('zodb_last_modified', 0.0):
    #    #    data  = self.downloadRev(reqrev='', REQUEST=request, RESPONSE=response)
    #    #else:
    #    #    data = File.manage_FTPget(self)
    
            
    
    
    security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'checkOut' )
    def checkOut(self, REQUEST, RESPONSE):
        values={}
        values['docstatus']='1'
        if values:
            self.processForm(data=1, metadata=0, REQUEST=None, values=values)
        
        self.changeActionUser(str(REQUEST.AUTHENTICATED_USER))
        
        
        #self.manage_changeProperties({'docstatus':'1',
        #                            'actionusr': str(REQUEST.AUTHENTICATED_USER),
        #                            'actiondate': DateTime()
        #                            })

    security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'checkIn' )
    def checkIn(self, file, log=''):
        #contact = self.portal_membership.getAuthenticatedMember().getUserName()
        #self.manage_changeProperties({'docstatus':'0',
        values={}
        values['docstatus']='0'
        self.processForm(data=1, metadata=0, REQUEST=None, values=values)
        self.REQUEST.set('log', log)
        self.changeFile(file)
        
    security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'approve' )
    def approve(self, REQUEST, RESPONSE):
        values={}
        values['docstatus']='2'
        if values:
            self.processForm(data=1, metadata=0, REQUEST=None, values=values)
        
        self.changeActionUser(str(REQUEST.AUTHENTICATED_USER))
        
        
    security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'undoaction' )
    def undoaction(self, REQUEST, RESPONSE):
        values={}
        values['docstatus']='0'
        if values:
            self.processForm(data=1, metadata=0, REQUEST=None, values=values)
        
        self.changeActionUser('')
        
        #RESPONSE.redirect(self.aq_parent.absolute_url()+'/view')
    
    def retrieve(self, filename="", tag="", recursive=1, prune_empty=0,pipe=0,
               new_dirs=0, reset_sticky=0):
        """
        perform a CVS update
        """
        
        
        cvs = self.RevisionManager._get_wrapper()
        
        cvs._prepare()
        cmdopt = ""
        if not recursive:
            cmdopt += "-l"
        if prune_empty:
            cmdopt += " -P"
        if pipe:
            cmdopt += " -p"
        if new_dirs:
            cmdopt += " -d"
        if reset_sticky:
            cmdopt += " -A"
        if tag:
            cmdopt = "-r %s %s" % (tag, cmdopt)
        result_val, result_out, result_err = \
                    cvs._exec_cmd("update", "", cmdopt, filename)
        cvs._clean_up()

        # updatedict = cvs.parse_listout(result_out)
        # updatedict.update(cvs.parse_update_removed(result_err))
        
        #****cvs update -A
        return result_out        
    

    security.declareProtected( CMFCorePermissions.View, 'downloadRev' )
    def downloadRev(self, reqrev='', REQUEST=None, RESPONSE=None):
        
        sg = ''
        sgPath= self.getRevPath()
        lastrev = self.getLastRevNo()
        if reqrev =='':
            reqrev = lastrev
        else:
            sg = '.' + reqrev + 'r'
        #sg = sg.replace('.', '_')
        #contentExt = self.getContentExtension()
        revmgr = self.RevisionManager
        #
        #
        #
        ##revmgr.update([sgPath], tag=reqrev, reset_sticky=1)
        #
        #paths=[sgPath]
        
        # it's better to use the rm_getRevision, as it need not overwrite the files in plone (it is written to a temp)
        return revmgr.rm_getRevision(REQUEST=REQUEST, RESPONSE=RESPONSE, path=sgPath, revision=reqrev)
        
        #settings = revmgr._settings
        ##if settings['save_properties']:
        ##    paths = revmgr.addPropertyPaths(paths)
        #escaped_paths = revmgr._escape_spaces(paths)
        #
        #
        ##abs_filename = revmgr.getAbsoluteFilePath(sgPath)
        #
        #data = self.retrieve(filename=" ".join(escaped_paths), tag=reqrev, pipe=1, reset_sticky=1)
        #
        #
        ##data = self.retrieve(filename=[sgPath], tag=reqrev, pipe=1)
        #
        ##abs_filename = revmgr.getAbsoluteFilePath(sgPath)
        ##data = open(abs_filename, "rb").read()
        #
        ##revmgr.update([sgPath], reset_sticky=1)
        #
        ##data = File.download(self, REQUEST, RESPONSE)
        #
        #
        #
        ##
        #RESPONSE.setHeader('Content-Type', 'application/download')
        #RESPONSE.setHeader('Content-Length', len(data))
        ##
        #filename=self.getId()
        #if filename[len(filename) - len(contentExt):] == contentExt:
        #    filename=filename[:len(filename) - len(contentExt)]
        #
        #filename=filename+ sg 
        #filename=filename + contentExt
        ##
        #RESPONSE.setHeader('Content-Disposition', 'attachment; filename=%s' % (filename))
        ##
        ###LOG('CMFDocMgt', INFO, '%d, %d, [%s]' %(len(self.getId()) , len(contentExt), self.getId()[:len(self.getId()) - len(contentExt)]))
        #return  data
        #
        ##field  = self.getField('file') 
        ##file   = field.get(self)
        ##ct     = self.getContentType()
        ##parent = aq_parent(self)
        ##f      = File(filename, filename, data, ct)
        ##return f.__of__(parent)


        
    security.declarePublic('getLastRevNo')
    def getLastRevNo(self):
        sgSrcRevPath = self.getRevPath()
        paths = [sgSrcRevPath]
        revmgr = self.RevisionManager
        #log = revmgr.log(paths)
        cvs = revmgr._get_wrapper()
        revmgr.clearLazyTraverse()
        log = cvs.log(" ".join(paths))
        
        filenames = log.keys()
        lastrev = ''
        lastrevdate = ''
        for f in paths:
            log_info = log[f]
            for rev in log_info['revisions']:
                moddate = rev['date'] #.strftime('%Y-%m-%d %I:%M:%S %p')
                if lastrevdate < moddate :
                    lastrevdate = moddate
                    lastrev = rev['revision']
        return lastrev

    security.declarePublic('getContentExtension')
    def getContentExtension(self):
        contenttype = self.get_content_type()
        if not contenttype:
            contenttype =''
        ext = mimetypes.guess_extension(contenttype)
        if not ext:
            ext=''
        
#        ret = ''
#        contenttype = self.content_type
#        if contenttype in ('application/msword', 'text/richtext'):
#            ret = 'doc'
#        elif contenttype=='application/vnd.ms-excel':
#            ret = 'xls'
#        elif contenttype=='application/pdf':
#            ret = 'pdf'
#        elif contenttype=='application/vnd.ms-powerpoint':
#            ret = 'ppt'
#        elif contenttype=='application/x-zip-compressed':
#            ret = 'zip'
#        elif contenttype=='audio/wav':
#            ret = 'wav'
#        elif contenttype=='application/vnd.rn-realmedia':
#            ret = 'rm'
#        elif contenttype=='video/x-ms-wmv':
#            ret = 'wmv'
#        elif contenttype=='video/mpeg':
#            ret = 'mpeg'
#        elif contenttype=='text/html':
#            ret = 'html'
#        elif contenttype=='text/plain':
#            ret = 'txt'
#        elif contenttype=='image/x-png':
#            ret = 'png'
#        elif contenttype=='image/gif':
#            ret = 'gif'
#        elif contenttype=='image/pjpeg':
#            ret = 'jpg'
#        elif contenttype=='audio/x-ms-wma':
#            ret = 'wma'
#        elif contenttype=='audio/x-pn-realaudio':
#            ret = 'rm'
#        elif contenttype=='application/x-shockwave-flash':
#            ret = 'swf'
#        else:
#            if contenttype.find('text') > -1:
#                ret = 'txt'
#            elif contenttype=='application/octet-stream':
#                ret = self.cmfdocmgt_tool.DefaultFileExtension #'dat'    #default file type
#        
        return ext



    def _check_lock(self):
        """ Check if the file is locked """
        emergency = 0
        user=getSecurityManager().getUser()
        
        if (SpecialUsers.emergency_user and
            aq_base(user) is SpecialUsers.emergency_user):
            emergency = 1
        
        docstatus = str(getattr(self, 'docstatus', '0')) 
        actionusr = str(getattr(self, 'actionusr', '')) 
        username = user.getUserName()
        if not emergency:
            if docstatus == '1' and \
                username <> actionusr and actionusr <> '':
           
                raise CMFDocMgtLockException, \
                  "This file is locked by %s. Document status is %s (Not normal)" + \
                  (username, docstatus)

            if docstatus >= '2':
           
                raise CMFDocMgtLockException, \
                  "This file is in approved state, you cannot update it."
        

    #############################################################################
    ##                             Syndication                                 ##
    #############################################################################

    security.declareProtected( CMFCorePermissions.View, 'queryCatalog' )
    def queryCatalog( self, REQUEST=None, **kw ):
        query = {'path': self.absolute_url('relative').replace('%20',' '),
                'meta_type' :['DocMgtFile'],
                }

        kw.update(query )
        return apply( self.portal_catalog.searchResults, ( REQUEST, ), kw )


    security.declarePublic('synContentValues')
    def synContentValues(self):
        """ play nice with portal_syndication_tool"""
        return self.queryCatalog()
        
    #############################################################################
    ##                             FTP                                         ##
    #############################################################################

    
    



    #security.declareProtected(CMFCorePermissions.View, 'manage_FTPget')
    #def manage_FTPget(self, REQUEST=None, RESPONSE=None):
    #    if not REQUEST:
    #        REQUEST = self.REQUEST
    #    if not RESPONSE:
    #        RESPONSE = REQUEST.RESPONSE
    #    
    #    return self.downloadRev(reqrev='', REQUEST=REQUEST, RESPONSE=RESPONSE)
    #    
    #    ##self._check_lock()
    #    ## don't write if it wasn't modified
    #    #obj_last_modified = float(self.bobobase_modification_time())
    #    #revmgr = self.getRM()
    #    #path= self.getRevPath()
    #    #obj_status = revmgr.getStatus(path)
    #    #data = File.manage_FTPget(self)
    #    ##if obj_last_modified < obj_status.get('zodb_last_modified', 0.0):
    #    ##    data  = self.downloadRev(reqrev='', REQUEST=request, RESPONSE=response)
    #    ##else:
    #    ##    data = File.manage_FTPget(self)
    #    #return data
    #manage_FTPget = ComputedAttribute(manage_FTPget, 1)
    #
     
    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'PUT','manage_FTPput')
    def PUT(self, REQUEST, RESPONSE):
        """ Handle HTTP (and presumably FTP?) PUT requests """
        #parent = self.findparent()
        if 0:
        #if not parent: 
        #if REQUEST.get('put_factory', ''):
            LOG('CMFDocMgt', INFO, '%s is a new file, and PUT_factory has handled the ftp process' % (self.getId()))
            return
        else:
            #LOG('CMFDocMgt', INFO, 'FTP uploading file in DocMgtFile.py %s ' % self.getId())
            
            #file=REQUEST['BODYFILE']
            body=REQUEST['BODY']
            
            #if body<>'':
            #    #type=REQUEST.get_header('content-type', None)
            #    #data, size = self._read_data(file)
            #    #content_type=self._get_content_type(file, data, self.__name__,
            #    #                            type or self.content_type)
            #    
            #    #log = 'FTP uploaded content'
            #    log = "FTP upload file"
            #    REQUEST.set('log', log)
            #    self.changeFile(body)
            #    
            #    #self.edit(file=body, docstatus='0', log=log)
            #
            #File.PUT( self, REQUEST, RESPONSE )
            
            values={}
            values['docstatus']='0'
            self.processForm(data=1, metadata=0, REQUEST=None, values=values)
            
            log = "FTP upload file"
            REQUEST.set('log', log)
            self.changeFile(body)
            
            
            #size= self.get_size()
            #if size >0:
            #
            #    #revmgr.status([newpath])
            #    log = 'FTP uploaded content'
            #    
            #    self.updateRev(log)
            #    
            #    #LOG('CMFDocMgt', INFO, 'File uploaded successfully')
    
    manage_FTPput = PUT


registerType(DocMgtFile, PROJECTNAME)
#registerType(DocMgtFile)
